QCA::MessageAuthenticationCode Class Reference
QCA user API

`#include <QtCrypto>`

Collaboration diagram for QCA::MessageAuthenticationCode:
[legend]

## Public Member Functions

void | clear () override
MemoryRegion | final () override
KeyLength | keyLength () const
| MessageAuthenticationCode (const MessageAuthenticationCode &from)
| MessageAuthenticationCode (const QString &type, const SymmetricKey &key, const QString &provider=QString())
MessageAuthenticationCode & | operator= (const MessageAuthenticationCode &from)
void | setup (const SymmetricKey &key)
QString | type () const
void | update (const MemoryRegion &array) override
bool | validKeyLength (int n) const
Public Member Functions inherited from QCA::Algorithm
| Algorithm (const Algorithm &from)
void | change (const QString &type, const QString &provider)
void | change (Provider::Context *c)
Provider::Context * | context ()
const Provider::Context * | context () const
Algorithm & | operator= (const Algorithm &from)
Provider * | provider () const
Provider::Context * | takeContext ()
QString | type () const
Public Member Functions inherited from QCA::BufferedComputation
MemoryRegion | process (const MemoryRegion &a)

## Static Public Member Functions

static QStringList | supportedTypes (const QString &provider=QString())

## Additional Inherited Members

Protected Member Functions inherited from QCA::Algorithm
| Algorithm ()
| Algorithm (const QString &type, const QString &provider)

## Detailed Description

General class for message authentication code (MAC) algorithms.

MessageAuthenticationCode is a class for accessing the various message authentication code algorithms within QCA. HMAC using SHA1 ("hmac(sha1)") or HMAC using SHA256 ("hmac(sha256)") is recommended for new applications.

Note that if your application is potentially susceptable to "replay attacks" where the message is sent more than once, you should include a counter in the message that is covered by the MAC, and check that the counter is always incremented every time you receive a message and MAC.

For more information on HMAC, see H. Krawczyk et al. RFC2104 "HMAC: Keyed-Hashing for Message Authentication"

Examples
  aes-cmac.cpp, and mactest.cpp.

## Constructor & Destructor Documentation

## MessageAuthenticationCode() [1/2]

QCA::MessageAuthenticationCode::MessageAuthenticationCode | ( | const QString & | type,
|  | const SymmetricKey & | key,
|  | const QString & | provider = QString() )

Standard constructor.

Parameters

  type | the name of the MAC (and algorithm, if applicable) to use
  key | the shared key
  provider | the provider to use, if a particular provider is required

References QCA::Algorithm::provider(), and type().

Referenced by MessageAuthenticationCode(), and operator=().

## MessageAuthenticationCode() [2/2]

QCA::MessageAuthenticationCode::MessageAuthenticationCode | ( | const MessageAuthenticationCode & | from | ) |

Standard copy constructor.

Copies the state (including key) from one MessageAuthenticationCode to another

Parameters

  from | the MessageAuthenticationCode to copy state from

References MessageAuthenticationCode().

## Member Function Documentation

## operator=()

MessageAuthenticationCode & QCA::MessageAuthenticationCode::operator= | ( | const MessageAuthenticationCode & | from | ) |

Assignment operator.

Copies the state (including key) from one MessageAuthenticationCode to another

Parameters

  from | the MessageAuthenticationCode to assign from.

References MessageAuthenticationCode().

## supportedTypes()

QStringList QCA::MessageAuthenticationCode::supportedTypes | ( | const QString & | provider = QString() | ) |

static

Returns a list of all of the message authentication code types available.

Parameters

  provider | the name of the provider to get a list from, if one provider is required. If not specified, available message authentication codes types from all providers will be returned.

References QCA::Algorithm::provider().

## type()

QString QCA::MessageAuthenticationCode::type | ( |  | ) | const

Return the MAC type.

Referenced by MessageAuthenticationCode().

## keyLength()

KeyLength QCA::MessageAuthenticationCode::keyLength | ( |  | ) | const

Return acceptable key lengths.

## validKeyLength()

bool QCA::MessageAuthenticationCode::validKeyLength | ( | int | n | ) | const

Test if a key length is valid for the MAC algorithm.

Parameters

  n | the key length in bytes

Returns
  true if the key would be valid for the current algorithm

## clear()

void QCA::MessageAuthenticationCode::clear | ( |  | ) |

override virtual

Reset a MessageAuthenticationCode, dumping all previous parts of the message.

This method clears (or resets) the algorithm, effectively undoing any previous update() calls. You should use this call if you are re-using a MessageAuthenticationCode sub-class object to calculate additional MACs. Note that if the key doesn't need to be changed, you don't need to call setup() again, since the key can just be reused.

Implements QCA::BufferedComputation.

## update()

void QCA::MessageAuthenticationCode::update | ( | const MemoryRegion & | array | ) |

override virtual

Update the MAC, adding more of the message contents to the digest.

The whole message needs to be added using this method before you call final().

Parameters

  array | the message contents

Implements QCA::BufferedComputation.

Examples
  mactest.cpp.

## final()

MemoryRegion QCA::MessageAuthenticationCode::final | ( |  | ) |

override virtual

Finalises input and returns the MAC result.

After calling update() with the required data, the hash results are finalised and produced.

Note that it is not possible to add further data (with update()) after calling final(). If you want to reuse the MessageAuthenticationCode object, you should call clear() and start to update() again.

Implements QCA::BufferedComputation.

Examples
  mactest.cpp.

## setup()

void QCA::MessageAuthenticationCode::setup | ( | const SymmetricKey & | key | ) |

Initialise the MAC algorithm.

Parameters

  key | the key to use for the algorithm

Examples
  mactest.cpp.

The documentation for this class was generated from the following file:

- qca_basic.h